# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.term_lang_pojo import TermLangPojo  # noqa: F401,E501


class ConceptMini(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'concept_id': 'str',
        'active': 'bool',
        'definition_status': 'str',
        'module_id': 'str',
        'effective_time': 'str',
        'fsn': 'TermLangPojo',
        'pt': 'TermLangPojo',
        'descendant_count': 'int',
        'is_leaf_inferred': 'bool',
        'is_leaf_stated': 'bool',
        'id': 'str'
    }

    attribute_map = {
        'concept_id': 'conceptId',
        'active': 'active',
        'definition_status': 'definitionStatus',
        'module_id': 'moduleId',
        'effective_time': 'effectiveTime',
        'fsn': 'fsn',
        'pt': 'pt',
        'descendant_count': 'descendantCount',
        'is_leaf_inferred': 'isLeafInferred',
        'is_leaf_stated': 'isLeafStated',
        'id': 'id'
    }

    def __init__(self, concept_id=None, active=None, definition_status=None, module_id=None, effective_time=None, fsn=None, pt=None, descendant_count=None, is_leaf_inferred=None, is_leaf_stated=None, id=None):  # noqa: E501
        """ConceptMini - a model defined in Swagger"""  # noqa: E501

        self._concept_id = None
        self._active = None
        self._definition_status = None
        self._module_id = None
        self._effective_time = None
        self._fsn = None
        self._pt = None
        self._descendant_count = None
        self._is_leaf_inferred = None
        self._is_leaf_stated = None
        self._id = None
        self.discriminator = None

        if concept_id is not None:
            self.concept_id = concept_id
        if active is not None:
            self.active = active
        if definition_status is not None:
            self.definition_status = definition_status
        if module_id is not None:
            self.module_id = module_id
        if effective_time is not None:
            self.effective_time = effective_time
        if fsn is not None:
            self.fsn = fsn
        if pt is not None:
            self.pt = pt
        if descendant_count is not None:
            self.descendant_count = descendant_count
        if is_leaf_inferred is not None:
            self.is_leaf_inferred = is_leaf_inferred
        if is_leaf_stated is not None:
            self.is_leaf_stated = is_leaf_stated
        if id is not None:
            self.id = id

    @property
    def concept_id(self):
        """Gets the concept_id of this ConceptMini.  # noqa: E501


        :return: The concept_id of this ConceptMini.  # noqa: E501
        :rtype: str
        """
        return self._concept_id

    @concept_id.setter
    def concept_id(self, concept_id):
        """Sets the concept_id of this ConceptMini.


        :param concept_id: The concept_id of this ConceptMini.  # noqa: E501
        :type: str
        """

        self._concept_id = concept_id

    @property
    def active(self):
        """Gets the active of this ConceptMini.  # noqa: E501


        :return: The active of this ConceptMini.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this ConceptMini.


        :param active: The active of this ConceptMini.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def definition_status(self):
        """Gets the definition_status of this ConceptMini.  # noqa: E501


        :return: The definition_status of this ConceptMini.  # noqa: E501
        :rtype: str
        """
        return self._definition_status

    @definition_status.setter
    def definition_status(self, definition_status):
        """Sets the definition_status of this ConceptMini.


        :param definition_status: The definition_status of this ConceptMini.  # noqa: E501
        :type: str
        """

        self._definition_status = definition_status

    @property
    def module_id(self):
        """Gets the module_id of this ConceptMini.  # noqa: E501


        :return: The module_id of this ConceptMini.  # noqa: E501
        :rtype: str
        """
        return self._module_id

    @module_id.setter
    def module_id(self, module_id):
        """Sets the module_id of this ConceptMini.


        :param module_id: The module_id of this ConceptMini.  # noqa: E501
        :type: str
        """

        self._module_id = module_id

    @property
    def effective_time(self):
        """Gets the effective_time of this ConceptMini.  # noqa: E501


        :return: The effective_time of this ConceptMini.  # noqa: E501
        :rtype: str
        """
        return self._effective_time

    @effective_time.setter
    def effective_time(self, effective_time):
        """Sets the effective_time of this ConceptMini.


        :param effective_time: The effective_time of this ConceptMini.  # noqa: E501
        :type: str
        """

        self._effective_time = effective_time

    @property
    def fsn(self):
        """Gets the fsn of this ConceptMini.  # noqa: E501


        :return: The fsn of this ConceptMini.  # noqa: E501
        :rtype: TermLangPojo
        """
        return self._fsn

    @fsn.setter
    def fsn(self, fsn):
        """Sets the fsn of this ConceptMini.


        :param fsn: The fsn of this ConceptMini.  # noqa: E501
        :type: TermLangPojo
        """

        self._fsn = fsn

    @property
    def pt(self):
        """Gets the pt of this ConceptMini.  # noqa: E501


        :return: The pt of this ConceptMini.  # noqa: E501
        :rtype: TermLangPojo
        """
        return self._pt

    @pt.setter
    def pt(self, pt):
        """Sets the pt of this ConceptMini.


        :param pt: The pt of this ConceptMini.  # noqa: E501
        :type: TermLangPojo
        """

        self._pt = pt

    @property
    def descendant_count(self):
        """Gets the descendant_count of this ConceptMini.  # noqa: E501


        :return: The descendant_count of this ConceptMini.  # noqa: E501
        :rtype: int
        """
        return self._descendant_count

    @descendant_count.setter
    def descendant_count(self, descendant_count):
        """Sets the descendant_count of this ConceptMini.


        :param descendant_count: The descendant_count of this ConceptMini.  # noqa: E501
        :type: int
        """

        self._descendant_count = descendant_count

    @property
    def is_leaf_inferred(self):
        """Gets the is_leaf_inferred of this ConceptMini.  # noqa: E501


        :return: The is_leaf_inferred of this ConceptMini.  # noqa: E501
        :rtype: bool
        """
        return self._is_leaf_inferred

    @is_leaf_inferred.setter
    def is_leaf_inferred(self, is_leaf_inferred):
        """Sets the is_leaf_inferred of this ConceptMini.


        :param is_leaf_inferred: The is_leaf_inferred of this ConceptMini.  # noqa: E501
        :type: bool
        """

        self._is_leaf_inferred = is_leaf_inferred

    @property
    def is_leaf_stated(self):
        """Gets the is_leaf_stated of this ConceptMini.  # noqa: E501


        :return: The is_leaf_stated of this ConceptMini.  # noqa: E501
        :rtype: bool
        """
        return self._is_leaf_stated

    @is_leaf_stated.setter
    def is_leaf_stated(self, is_leaf_stated):
        """Sets the is_leaf_stated of this ConceptMini.


        :param is_leaf_stated: The is_leaf_stated of this ConceptMini.  # noqa: E501
        :type: bool
        """

        self._is_leaf_stated = is_leaf_stated

    @property
    def id(self):
        """Gets the id of this ConceptMini.  # noqa: E501


        :return: The id of this ConceptMini.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ConceptMini.


        :param id: The id of this ConceptMini.  # noqa: E501
        :type: str
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConceptMini):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
